"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var utils_1 = require("./utils");
var merge_nodes_1 = require("./merge-nodes");
var helpers_1 = require("../../utils/helpers");
var utils_2 = require("../../utils");
function mergeGraphQLSchemas() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    console.info("\n    GraphQL Toolkit/Epoxy \n    Deprecation Notice;\n    'mergeGraphQLSchemas' is deprecated and will be removed in the next version.\n    Please use 'mergeTypeDefs' instead!\n  ");
    return mergeGraphQLTypes.apply(void 0, args);
}
exports.mergeGraphQLSchemas = mergeGraphQLSchemas;
function mergeTypeDefs(types, config) {
    return {
        kind: 'Document',
        definitions: mergeGraphQLTypes(types, __assign({ useSchemaDefinition: true }, config)),
    };
}
exports.mergeTypeDefs = mergeTypeDefs;
function mergeGraphQLTypes(types, config) {
    var allNodes = types
        .map(function (type) {
        if (utils_1.isGraphQLSchema(type)) {
            return utils_2.printSchema(type);
        }
        else if (utils_1.isStringTypes(type) || utils_1.isSourceTypes(type)) {
            return graphql_1.parse(type);
        }
        return type;
    })
        .map(function (ast) { return ast.definitions; })
        .reduce(function (defs, newDef) { return defs.concat(newDef); }, []);
    // XXX: right now we don't handle multiple schema definitions
    var schemaDef = allNodes.filter(utils_1.isSchemaDefinition).reduce(function (def, node) {
        node.operationTypes
            .filter(function (op) { return op.type.name.value; })
            .forEach(function (op) {
            def[op.operation] = op.type.name.value;
        });
        return def;
    }, {
        query: null,
        mutation: null,
        subscription: null,
    });
    var mergedNodes = merge_nodes_1.mergeGraphQLNodes(allNodes);
    var allTypes = Object.keys(mergedNodes);
    if (config && config.useSchemaDefinition) {
        var queryType = schemaDef.query ? schemaDef.query : allTypes.find(function (t) { return t === 'Query'; });
        var mutationType = schemaDef.mutation ? schemaDef.mutation : allTypes.find(function (t) { return t === 'Mutation'; });
        var subscriptionType = schemaDef.subscription ? schemaDef.subscription : allTypes.find(function (t) { return t === 'Subscription'; });
        schemaDef = {
            query: queryType,
            mutation: mutationType,
            subscription: subscriptionType,
        };
    }
    var schemaDefinition = helpers_1.createSchemaDefinition(schemaDef);
    if (!schemaDefinition) {
        return Object.values(mergedNodes);
    }
    return Object.values(mergedNodes).concat([graphql_1.parse(schemaDefinition).definitions[0]]);
}
exports.mergeGraphQLTypes = mergeGraphQLTypes;
//# sourceMappingURL=merge-typedefs.js.map